    const int SCARD_STATE_UNAWARE = 0x0000;
    const int SCARD_STATE_IGNORE = 0x0001;
    const int SCARD_STATE_CHANGED = 0x0002;
    const int SCARD_STATE_UNKNOWN = 0x0004;
    const int SCARD_STATE_UNAVAILABLE = 0x0008;
    const int SCARD_STATE_EMPTY = 0x0010;
    const int SCARD_STATE_PRESENT = 0x0020;
    const int SCARD_STATE_ATRMATCH = 0x0040;
    const int SCARD_STATE_EXCLUSIVE = 0x0080;
    const int SCARD_STATE_INUSE = 0x0100;
    const int SCARD_STATE_MUTE = 0x0200;
    
const char *StateToStr(int State)
{
  int empty = State & SCARD_STATE_EMPTY;
  int unaware = State & SCARD_STATE_UNAWARE;
  int ignore = State & SCARD_STATE_IGNORE;
  int changed = State & SCARD_STATE_CHANGED;
  int unknown = State & SCARD_STATE_UNKNOWN;
  int unavailable = State & SCARD_STATE_UNAVAILABLE;
  int present = State & SCARD_STATE_PRESENT;
  int atrMatch = State & SCARD_STATE_ATRMATCH;
  int exclusive = State & SCARD_STATE_EXCLUSIVE;
  int inuse = State & SCARD_STATE_INUSE;
  int mute = State & SCARD_STATE_MUTE;

  if (mute != 0) 
    return "SCARD_STATE_MUTE";
  if (inuse != 0)
    return "SCARD_STATE_INUSE";
  if (exclusive != 0)
    return "SCARD_STATE_EXCLUSIVE";
  if (atrMatch !=0)
    return "SCARD_STATE_ATRMATCH";
  if (present !=0)
    return "SCARD_STATE_PRESENT";
  if (empty !=0)
    return "SCARD_STATE_EMPTY";
  if (unavailable !=0)
    return "SCARD_STATE_UNAVAILABLE";
  if (unknown != 0)
    return "SCARD_STATE_UNKNOWN";
  if (changed != 0)
    return "SCARD_STATE_CHANGED";
  if (ignore != 0)
    return "SCARD_STATE_IGNORE";
  if (unaware != 0)
    return "SCARD_STATE_UNAWARE";
  return "Unknown state code ";
}
   
